<?php

namespace Yana\Location\Http\Controllers;

use App\Http\Controllers\PublicController as BaseController;
use Yana\Location\Interfaces\LocationRepositoryInterface;

class LocationPublicController extends BaseController
{
    // use LocationWorkflow;

    /**
     * Constructor.
     *
     * @param type \Yana\Location\Interfaces\LocationRepositoryInterface $location
     *
     * @return type
     */
    public function __construct(LocationRepositoryInterface $location)
    {
        $this->repository = $location;
        parent::__construct();
    }

    /**
     * Show location's list.
     *
     * @param string $slug
     *
     * @return response
     */
    protected function index()
    {
        $locations = $this->repository
        ->pushCriteria(app('Litepie\Repository\Criteria\RequestCriteria'))
        ->scopeQuery(function($query){
            return $query->orderBy('id','DESC');
        })->paginate();

        return $this->theme->of('location::public.location.index', compact('locations'))->render();
    }

    /**
     * Show location.
     *
     * @param string $slug
     *
     * @return response
     */
    protected function show($slug)
    {
        $location = $this->repository->scopeQuery(function($query) use ($slug) {
            return $query->orderBy('id','DESC')
                         ->where('slug', $slug);
        })->first(['*']);

        return $this->theme->of('location::public.location.show', compact('location'))->render();
    }

}
